﻿''' <summary>
''' Stellt ein internes Nachrichtenfenster bereit.
''' </summary>
Friend Class InternalMsgBoxEx

      Private FormAdditionalHeight As Integer
      Private PanelButtonsHeight As Integer
      Private MinLabelHeight32 As Integer
      Private lblIconWidth32 As Integer

      Private MyMessage As String

#Region " AdjustButtons "
      Private B1Left As Integer 'Left-Wert für Button 1
      Private B2Left As Integer 'Left-Wert für Button 2
      Private B3Left As Integer 'Left-Wert für Button 3
      Private ButtonCount As Integer = 0

      Private Sub HandleDefaultButton()
         Select Case mDefaultButton
            Case UrsExtendedMsgBox.DefaultButtons.Button1
               Button1.Focus()
               Button1.Select()
            Case UrsExtendedMsgBox.DefaultButtons.Button2
               If ButtonCount > 1 Then
                  Button2.Focus()
                  Button2.Select()
               Else
                  Button1.Focus()
                  Button1.Select()
               End If
            Case UrsExtendedMsgBox.DefaultButtons.Button3
               If ButtonCount > 2 Then
                  Button3.Focus()
                  Button3.Select()
               Else
                  Button1.Focus()
                  Button1.Select()
               End If
         End Select
      End Sub

      Private Sub AdjustButtons()
         Select Case mShowButtons
            Case UrsExtendedMsgBox.ButtonList.OkOnly
               ButtonCount = 1
               Button1.Text = "&OK"
               Button1.Left = B3Left
               Button1.Tag = DialogResult.OK
               Button2.Visible = False
               Button3.Visible = False
            Case UrsExtendedMsgBox.ButtonList.OkCancel
               ButtonCount = 2
               Button1.Text = "&OK"
               Button1.Left = B2Left
               Button1.Tag = DialogResult.OK
               Button2.Text = "&Abbrechen"
               Button2.Left = B3Left
               Button2.Tag = DialogResult.Cancel
               Button2.Visible = True
               Button3.Visible = False
            Case UrsExtendedMsgBox.ButtonList.RetryCancel
               ButtonCount = 2
               Button1.Text = "&Wiederholen"
               Button1.Left = B2Left
               Button1.Tag = DialogResult.Retry
               Button2.Text = "&Abbrechen"
               Button2.Left = B3Left
               Button2.Tag = DialogResult.Cancel
               Button2.Visible = True
               Button3.Visible = False
            Case UrsExtendedMsgBox.ButtonList.YesNo
               ButtonCount = 2
               Button1.Text = "&Ja"
               Button1.Left = B2Left
               Button1.Tag = DialogResult.Yes
               Button2.Text = "&Nein"
               Button2.Left = B3Left
               Button2.Tag = DialogResult.No
               Button2.Visible = True
               Button3.Visible = False
            Case UrsExtendedMsgBox.ButtonList.YesNoCancel
               ButtonCount = 3
               Button1.Text = "&Ja"
               Button1.Left = B1Left
               Button1.Tag = DialogResult.Yes
               Button2.Text = "&Nein"
               Button2.Left = B2Left
               Button2.Tag = DialogResult.No
               Button2.Visible = True
               Button3.Text = "&Abbrechen"
               Button3.Left = B3Left
               Button3.Tag = DialogResult.Cancel
               Button3.Visible = True
            Case UrsExtendedMsgBox.ButtonList.AbortRetryIgnore
               ButtonCount = 3
               Button1.Text = "&Abbrechen"
               Button1.Left = B1Left
               Button1.Tag = DialogResult.Abort
               Button2.Text = "&Wiederholen"
               Button2.Left = B2Left
               Button2.Tag = DialogResult.Retry
               Button2.Visible = True
               Button3.Text = "&Ignorieren"
               Button3.Left = B3Left
               Button3.Tag = DialogResult.Ignore
               Button3.Visible = True
         End Select

         HandleDefaultButton()
      End Sub
#End Region

#Region " AdjustFormHeight "
      Private Sub AdjustFormHeight()
         If mIconSize = UrsExtendedMsgBox.IconSizes.Icons32 Then
            lblIcon.Width = lblIconWidth32

            ' Höhe des Nachrichten-Bereichs in Abhängigkeit vom Icon und der Höhe des umgebrochen Textes
            lblTest.Left = lblMsg.Left
            lblTest.MaximumSize = New Size(lblMsg.Width, 0)
            lblTest.Text = MyMessage

            If lblTest.Height > MinLabelHeight32 Then
               PanelMsg.Height = lblTest.Height
            Else
               PanelMsg.Height = MinLabelHeight32
            End If
         Else ' MsgBoxEx.IconSizes.Icons64
            lblIcon.Width = lblIconWidth32 + 32

            lblTest.Left = lblMsg.Left
            lblTest.MaximumSize = New Size(lblMsg.Width, 0)
            lblTest.Text = MyMessage

            If lblTest.Height > MinLabelHeight32 + 32 Then
               PanelMsg.Height = lblTest.Height
            Else
               PanelMsg.Height = MinLabelHeight32 + 32
            End If
         End If

         PanelButtons.Top = PanelMsg.Height

         If mShowCopyButton Then
            PanelButtons.Height = PanelButtonsHeight
         Else
            PanelButtons.Height = PanelButtonsHeight - (cmdCopy.Height - Button1.Height)
         End If

         Height = FormAdditionalHeight + PanelMsg.Height + PanelButtons.Height
      End Sub
#End Region

#Region " Properties "
      ''' <summary>
      ''' Die anzuzeigende Nachricht.
      ''' </summary>
      ''' <value> Die anzuzeigende Nachricht.</value>
      Public Property Prompt As String
         Get
            Return lblMsg.Text
         End Get
         Set(value As String)
            MyMessage = value
            lblMsg.Text = value
            AdjustFormHeight()
         End Set
      End Property
#Region " ShowButtons "
      Private mShowButtons As UrsExtendedMsgBox.ButtonList = UrsExtendedMsgBox.ButtonList.OkOnly
      ''' <summary>
      ''' Gibt an, welche Schlatflächen aktiv sind, oder legt dies fest.
      ''' </summary>
      ''' <value>Die Angabe, welche Schaltflächen aktiv sein sollen.</value>
      Public Property ShowButtons As UrsExtendedMsgBox.ButtonList
         Get
            Return mShowButtons
         End Get
         Set(value As UrsExtendedMsgBox.ButtonList)
            mShowButtons = value
            AdjustButtons()
         End Set
      End Property
#End Region
#Region " DefaultButton "
      Private mDefaultButton As UrsExtendedMsgBox.DefaultButtons = UrsExtendedMsgBox.DefaultButtons.Button1
      ''' <summary>
      ''' Gibt an, welches die Standard-Schaltfläche ist, oder legt dies fest.
      ''' </summary>
      ''' <value>Die Angabe, welche die Standard-Schaltfläche ist.</value>
      Public Property DefaultButton As UrsExtendedMsgBox.DefaultButtons
         Get
            Return mDefaultButton
         End Get
         Set(value As UrsExtendedMsgBox.DefaultButtons)
            mDefaultButton = value ' speichern, falls sich Buttons später ändert

            HandleDefaultButton()
         End Set
      End Property
#End Region
#Region " IconSize "
      Private mIconSize As UrsExtendedMsgBox.IconSizes = UrsExtendedMsgBox.IconSizes.Icons32

      ''' <summary>
      ''' Ruft die Symbolgröße ab oder legt sie fest.
      ''' </summary>
      ''' <value>Die Angabe zur Symbolgröße.</value>
      Public Property IconSize As UrsExtendedMsgBox.IconSizes
         Get
            Return mIconSize
         End Get
         Set(value As UrsExtendedMsgBox.IconSizes)
            mIconSize = value

            If value = UrsExtendedMsgBox.IconSizes.Icons32 Then
               lblIcon.ImageList = Icons32
            Else
               lblIcon.ImageList = Icons64
            End If

            AdjustFormHeight()
         End Set
      End Property
#End Region
#Region " ShowCopyButton "
      Private mShowCopyButton As Boolean
      ''' <summary>
      ''' Gibt an, ob die Schaltfläche "Nachricht kopieren" angezeigt werden soll.
      ''' </summary>
      ''' <remarks>Über die Schaltfläche "Meldung kopieren" wird der Text der Nachricht in die Zwischenablage kopiert.</remarks>
      Public Property ShowCopyButton As Boolean
         Get
            Return mShowCopyButton
         End Get
         Set(value As Boolean)
            mShowCopyButton = value
            cmdCopy.Visible = value ' Wird erst verzögert wirksam
            cmdCopy.Refresh()
            AdjustFormHeight()
         End Set
      End Property
#End Region
#End Region

#Region " Constructor "
      Public Sub New(Msg As String, MsgType As UrsExtendedMsgBox.MsgTypes, Caption As String)
         InitializeComponent()
         MyMessage = Msg
         lblMsg.Text = Msg
         Text = Caption

         If MsgType = UrsExtendedMsgBox.MsgTypes.None Then
            lblIcon.Visible = False
         End If

         B1Left = Button1.Left
         B2Left = Button2.Left
         B3Left = Button3.Left

         FormAdditionalHeight = Height - PanelMsg.Height - PanelButtons.Height
         PanelButtonsHeight = PanelButtons.Height
         MinLabelHeight32 = lblMsg.Height
         lblIconWidth32 = lblIcon.Width

         ShowButtons = mShowButtons ' Schlatflächen und DefaultButton initialisieren
         IconSize = mIconSize ' IconSize initilaisieren

         AdjustFormHeight()


         lblIcon.ImageIndex = MsgType
      End Sub
#End Region

      Public Sub Abort()
         DialogResult = DialogResult.Cancel
         Close()
      End Sub

#Region " Schaltflächen "
      Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button1.Click, Button2.Click, Button3.Click
         Dim ctrl As Control = CType(sender, Control)
         DialogResult = CType(ctrl.Tag, DialogResult)
         Close()
      End Sub

      Private Sub cmdCopy_Click(sender As Object, e As EventArgs) Handles cmdCopy.Click
         Clipboard.SetText(lblMsg.Text)
         cmdCopy.Visible = False
         lblCopyMsg.Visible = True
         Timer1.Enabled = True
      End Sub
#End Region

      Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
         cmdCopy.Visible = True
         lblCopyMsg.Visible = False
         Timer1.Enabled = False
      End Sub

      Private Sub InternalMsgBoxEx_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
         If e.KeyCode = 112 Then
            OnHelpButtonClicked(New ComponentModel.CancelEventArgs)
         End If
      End Sub
End Class